Exercise 09: Websocket
==========================================================

CSCM602023 - Advanced Programming (Pemrograman Lanjut) @ Faculty of
Computer Science Universitas Indonesia, Even Semester 2016/2017

* * *

Your main tasks in this week exercise is to explore
available library of websocket in python and learn how it works.
You need to run the example and do small modification to show
your understanding of how it works and able to explain it.


Mandatory Tasks Description
---------------------------

There are several available libraries for websocket in python.
You are free to choose any of them to create a very simple
web-based chatting application.

Mandatory Checklist
-------------------

- [ ] run at least two libraries from any resources/library about websocket.
- [ ] choose one of them to have a simple web-based chatting. You can use an already prepared example by the author.
- [ ] prettify it with nice layout (css) or have scroll-able frame, etc if needed.
- [ ] name the main file as `week9.py` and ensure it is working properly from several running browser to simulate the chatting activities.
- [ ] write some notes with your own words that explain how the web-based chat works. Write it as a markdown text file in your repository. (just like this README.md file). It should be equivalent to at least one page A4 printed.
- [ ] commit and push your mandatory work related to `week9.py` to your own Git repository. Don't forget to add and include all related files and required library.
- [ ] show your works, by running it on a fresh clone from the repository

Additional Checklist
--------------------

Please include data that supports your answer, e.g. screenshot of several browser doing chatting, by adding it in the Git repository.  

- [ ] add at least one new functionality to your web-based chat. Here are some examples:
    * let the user (chatter) identified him/her self.
    * let the server frequently send the user of nice/valuable quote.
    * let the server send you latest news or specific news.
    * let the server inform the number of active chatters.
- [ ] Write additional notes that explain how did you modify the example to add the new functionality. Write your notes as a markdown file in you repository. It should be equivalent to at least two page A4 printed.
- [ ] Commit and push your additional works to your own Git repository.
- [ ] Show your works, by running it on a fresh clone from the repository

- - -

List of some libraries with examples
------------------------------------

* http://flask-socketio.readthedocs.io/en/latest/
* https://github.com/makaimc/python-websockets-example
* http://blog.miguelgrinberg.com/post/easy-websockets-with-flask-and-gevent
* http://blog.pythonisito.com/2012/07/realtime-web-chat-with-socketio-and.html
* https://pythonhosted.org/pulsar/tutorials/chat.html
* https://github.com/heroku-examples/python-websockets-chat

- - -
**End of Week 9 Exercise**
